package org.drools.cep;

import java.util.*;
import org.drools.model.*;
import org.drools.modelcompiler.dsl.pattern.D;
import org.drools.model.Index.ConstraintType;
import java.time.*;
import java.time.format.*;
import java.text.*;
import org.drools.core.util.*;
import org.kie.hacep.sample.kjar.StockTickEvent;
import java.util.UUID;
import org.kie.remote.DroolsExecutor;
import org.kie.hacep.sample.kjar.Result;
import static org.drools.cep.RulesDFF7CC07691E1DE9BB71E1BADFF21DDB.*;

public class RulesDFF7CC07691E1DE9BB71E1BADFF21DDBRuleMethods0 {

    /**
     * Rule name: StockAverage
     */
    public static org.drools.model.Rule rule_StockAverage() {
        final org.drools.model.Variable<org.kie.hacep.sample.kjar.Result> var_$r = D.declarationOf(org.kie.hacep.sample.kjar.Result.class,
                                                                                                   DomainClassesMetadataDFF7CC07691E1DE9BB71E1BADFF21DDB.org_kie_hacep_sample_kjar_Result_Metadata_INSTANCE,
                                                                                                   "$r");
        final org.drools.model.Variable<java.lang.String> var_$name = D.declarationOf(java.lang.String.class,
                                                                                      DomainClassesMetadataDFF7CC07691E1DE9BB71E1BADFF21DDB.java_lang_String_Metadata_INSTANCE,
                                                                                      "$name");
        final org.drools.model.Variable<org.kie.hacep.sample.kjar.StockTickEvent> var_GENERATED_$pattern_StockTickEvent$1$ = D.declarationOf(org.kie.hacep.sample.kjar.StockTickEvent.class,
                                                                                                                                             DomainClassesMetadataDFF7CC07691E1DE9BB71E1BADFF21DDB.org_kie_hacep_sample_kjar_StockTickEvent_Metadata_INSTANCE,
                                                                                                                                             "GENERATED_$pattern_StockTickEvent$1$");
        final org.drools.model.Variable<Double> var_$p = D.declarationOf(Double.class,
                                                                         "$p");
        final org.drools.model.Variable<java.lang.Double> var_$avg = D.declarationOf(java.lang.Double.class,
                                                                                     DomainClassesMetadataDFF7CC07691E1DE9BB71E1BADFF21DDB.java_lang_Double_Metadata_INSTANCE,
                                                                                     "$avg");
        org.drools.model.Rule rule = D.rule("org.drools.cep",
                                            "StockAverage").build(D.pattern(var_$r).bind(var_$name,
                                                                                         org.drools.cep.PD6.LambdaExtractorD6CE2D6C141CCC82173387826A2626DF.INSTANCE,
                                                                                         D.reactOn("stockName")),
                                                                  D.accumulate(D.pattern(var_GENERATED_$pattern_StockTickEvent$1$).expr("E44016C0D11BC5C44AC48D88E9FD4D6A",
                                                                                                                                        var_$name,
                                                                                                                                        org.drools.cep.P56.LambdaPredicate56F4803F5E6CA8D99B8296B926ECA64C.INSTANCE,
                                                                                                                                        D.betaIndexedBy(java.lang.String.class,
                                                                                                                                                        org.drools.model.Index.ConstraintType.EQUAL,
                                                                                                                                                        DomainClassesMetadataDFF7CC07691E1DE9BB71E1BADFF21DDB.org_kie_hacep_sample_kjar_StockTickEvent_Metadata_INSTANCE.getPropertyIndex("company"),
                                                                                                                                                        org.drools.cep.PEE.LambdaExtractorEEC8F166BF997716F7FD532DEE05FFDB.INSTANCE,
                                                                                                                                                        org.drools.cep.PF0.LambdaExtractorF0306571349D17DC48D6959B48A53DC7.INSTANCE),
                                                                                                                                        D.reactOn("company")).bind(var_$p,
                                                                                                                                                                   org.drools.cep.PEC.LambdaExtractorEC7602CFA059620205973B59A7A4307A.INSTANCE,
                                                                                                                                                                   D.reactOn("price")),
                                                                               D.accFunction(org.drools.core.base.accumulators.AverageAccumulateFunction::new,
                                                                                             var_$p).as(var_$avg)),
                                                                  D.on(var_$name,
                                                                       var_$r,
                                                                       var_$avg).execute(org.drools.cep.P9F.LambdaConsequence9F74C4E8F910B725BE8366B3407195D9.INSTANCE));
        return rule;
    }

    /**
     * Rule name: StockLog
     */
    public static org.drools.model.Rule rule_StockLog() {
        final org.drools.model.Variable<org.kie.hacep.sample.kjar.StockTickEvent> var_$stock = D.declarationOf(org.kie.hacep.sample.kjar.StockTickEvent.class,
                                                                                                               DomainClassesMetadataDFF7CC07691E1DE9BB71E1BADFF21DDB.org_kie_hacep_sample_kjar_StockTickEvent_Metadata_INSTANCE,
                                                                                                               "$stock");
        org.drools.model.Rule rule = D.rule("org.drools.cep",
                                            "StockLog").build(D.pattern(var_$stock),
                                                              D.on(var_$stock).execute(org.drools.cep.P10.LambdaConsequence102DBE8549C2AB0AAD134239F90CD014.INSTANCE));
        return rule;
    }
}
